Bug 1890125 (CVE-2020-25686) - CVE-2020-25686 dnsmasq: multiple queries forwarded for the same name makes forging replies easier for an off-path attacker
Summary: CVE-2020-25686 dnsmasq: multiple queries forwarded for the same name makes fo...
Keywords:
Status: CLOSED ERRATA
Alias: CVE-2020-25686
Product: Security Response
Classification: Other
Component: vulnerability
Version: unspecified
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard:
Depends On: 1896063 1896066 1896068 1896070 1896072 1896073 1896074 1896075 1905021 1905022 1905023 1917321 1917322 1917787 1917793 1918955 1918956
Blocks: 1875522
TreeView+ depends on / blocked
 
Reported: 2020-10-21 13:07 UTC by Riccardo Schirone
Modified: 2022-04-17 21:02 UTC (History)
29 users (show)

Fixed In Version: dnsmasq 2.83
Doc Type: Known Issue
Doc Text:
A flaw was found in dnsmasq. When receiving a query, dnsmasq does not check for an existing pending request for the same name and forwards a new request. By default, a maximum of 150 pending queries can be sent to upstream servers, so there can be at most 150 queries for the same name. This flaw allows an off-path attacker on the network to substantially reduce the number of attempts that it would have to perform to forge a reply and have it accepted by dnsmasq. This issue is mentioned in the "Birthday Attacks" section of RFC5452. If chained with CVE-2020-25684, the attack complexity of a successful attack is reduced. The highest threat from this vulnerability is to data integrity.
Clone Of:
Environment:
Last Closed: 2021-01-19 17:59:29 UTC


Attachments (Terms of Use)


Links
System ID Private Priority Status Summary Last Updated
Red Hat Product Errata RHBA-2021:0199 0 None None None 2021-01-20 18:19:10 UTC
Red Hat Product Errata RHBA-2021:0242 0 None None None 2021-01-25 17:13:26 UTC
Red Hat Product Errata RHSA-2021:0150 0 None None None 2021-01-19 13:16:49 UTC
Red Hat Product Errata RHSA-2021:0151 0 None None None 2021-01-19 13:34:25 UTC
Red Hat Product Errata RHSA-2021:0152 0 None None None 2021-01-19 13:11:50 UTC
Red Hat Product Errata RHSA-2021:0153 0 None None None 2021-01-19 13:55:02 UTC
Red Hat Product Errata RHSA-2021:0154 0 None None None 2021-01-19 13:57:35 UTC
Red Hat Product Errata RHSA-2021:0155 0 None None None 2021-01-19 14:08:14 UTC
Red Hat Product Errata RHSA-2021:0156 0 None None None 2021-01-19 13:36:07 UTC
Red Hat Product Errata RHSA-2021:0240 0 None None None 2021-01-25 14:22:21 UTC
Red Hat Product Errata RHSA-2021:0245 0 None None None 2021-01-25 15:11:04 UTC
Red Hat Product Errata RHSA-2021:0395 0 None None None 2021-02-03 10:37:33 UTC
Red Hat Product Errata RHSA-2021:0401 0 None None None 2021-02-03 16:13:10 UTC

Description Riccardo Schirone 2020-10-21 13:07:53 UTC
When receiving a query, dnsmasq does not check if there is already a pending request for the same name and it forwards a new request for it. By default a maximum of 150 pending queries can be sent to upstream servers, so there can be at most 150 queries for the same name. An attacker on the network can abuse this issue to substantially reduce the number of attempts he would have to perform to forge a reply and get it accepted by dnsmasq. This is mentioned in the "Birthday Attacks" section of RFC5452.

Comment 13 lnacshon 2020-12-07 11:29:21 UTC
OSD3 services are using dnsmasq shipped directly by RHEL7, each node has its own dnsmasq

Comment 19 Riccardo Schirone 2021-01-14 11:32:19 UTC
Red Hat Enterprise Linux 5, 6, 7, and 8 are all affected in the same way and the same mitigations apply.

Comment 20 Eric Christensen 2021-01-14 19:51:25 UTC
Mitigation:

The impact of this flaw can be reduced by disabling the dnsmasq cache by adding `--cache-size=0` when calling dnsmasq or by adding a line with `cache-size=0` to the dnsmasq configuration file (/etc/dnsmasq.conf by default). 

When using Red Hat Enterprise Linux 8.3 with libvirt through a virt:rhel module, use `virsh net-edit <network-name>` and reference https://libvirt.org/formatnetwork.html#elementsNamespaces to add the suggested option `cache-size=0`. 

There is no way to customize the dnsmasq configuration generated by libvirt, when using versions of Red Hat Enterprise Linux prior to version 8.3. If dnsmasq is being run through NetworkManager, create a new file in /etc/NetworkManager/dnsmasq.d/ and add `cache-size=0` to it.

In all cases, by disabling the cache, you may experience a performance loss in your environment due to all DNS queries being forwarded to the upstream servers. Please evaluate if the mitigation is appropriate for the system’s environment before applying.

Comment 21 Riccardo Schirone 2021-01-15 14:47:54 UTC
Statement:

Dnsmasq may be run by libvirt and/or NetworkManager. libvirt uses dnsmasq by default to provide DNS service to its guests. NetworkManager may be configured to use dnsmasq to provide DNS service to the system, if a line `dns=dnsmasq` is present in the `[main]` section of the configuration file /etc/NetworkManager/NetworkManager.conf.

In Red Hat OpenStack Platform (RHOSP) and Red Hat Virtualization (RHV), the dnsmasq package is provided by the underlying Red Hat Enterprise Linux (RHEL) product. RHOSP and RHV are therefore indirectly affected, so please ensure that the underlying RHEL dnsmasq package is updated.

Comment 22 Riccardo Schirone 2021-01-15 17:16:40 UTC
Acknowledgments:

Name: Moshe Kol (JSOF), Shlomi Oberman (JSOF)

Comment 24 Riccardo Schirone 2021-01-19 11:36:05 UTC
External References:

https://www.jsof-tech.com/disclosures/dnspooq/

Comment 25 Riccardo Schirone 2021-01-19 11:56:30 UTC
Created dnsmasq tracking bugs for this issue:

Affects: fedora-all [bug 1917787]

Comment 27 errata-xmlrpc 2021-01-19 13:11:48 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 8.1 Extended Update Support

Via RHSA-2021:0152 https://access.redhat.com/errata/RHSA-2021:0152

Comment 28 errata-xmlrpc 2021-01-19 13:16:45 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 8

Via RHSA-2021:0150 https://access.redhat.com/errata/RHSA-2021:0150

Comment 30 errata-xmlrpc 2021-01-19 13:34:20 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 8.2 Extended Update Support

Via RHSA-2021:0151 https://access.redhat.com/errata/RHSA-2021:0151

Comment 31 errata-xmlrpc 2021-01-19 13:36:44 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 7.4 Advanced Update Support
  Red Hat Enterprise Linux 7.4 Update Services for SAP Solutions
  Red Hat Enterprise Linux 7.4 Telco Extended Update Support

Via RHSA-2021:0156 https://access.redhat.com/errata/RHSA-2021:0156

Comment 32 errata-xmlrpc 2021-01-19 13:55:00 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 7

Via RHSA-2021:0153 https://access.redhat.com/errata/RHSA-2021:0153

Comment 33 errata-xmlrpc 2021-01-19 13:58:13 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 7.7 Extended Update Support

Via RHSA-2021:0154 https://access.redhat.com/errata/RHSA-2021:0154

Comment 34 errata-xmlrpc 2021-01-19 14:08:51 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 7.6 Extended Update Support

Via RHSA-2021:0155 https://access.redhat.com/errata/RHSA-2021:0155

Comment 35 Product Security DevOps Team 2021-01-19 17:59:29 UTC
This bug is now closed. Further updates for individual products will be reflected on the CVE page(s):

https://access.redhat.com/security/cve/cve-2020-25686

Comment 37 errata-xmlrpc 2021-01-25 14:22:18 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 7.2 Advanced Update Support

Via RHSA-2021:0240 https://access.redhat.com/errata/RHSA-2021:0240

Comment 38 errata-xmlrpc 2021-01-25 15:11:00 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 7.3 Advanced Update Support

Via RHSA-2021:0245 https://access.redhat.com/errata/RHSA-2021:0245

Comment 39 errata-xmlrpc 2021-02-03 10:37:26 UTC
This issue has been addressed in the following products:

  Red Hat Virtualization 4 for Red Hat Enterprise Linux 7

Via RHSA-2021:0395 https://access.redhat.com/errata/RHSA-2021:0395

Comment 40 errata-xmlrpc 2021-02-03 16:13:07 UTC
This issue has been addressed in the following products:

  Red Hat Virtualization 4 for Red Hat Enterprise Linux 8

Via RHSA-2021:0401 https://access.redhat.com/errata/RHSA-2021:0401


Note You need to log in before you can comment on or make changes to this bug.